import * as i0 from '@angular/core';
import { TemplateRef, Directive, Inject, Input, ContentChild, NgModule, QueryList, Component, ChangeDetectionStrategy, ContentChildren } from '@angular/core';
import { __decorate, __metadata } from 'tslib';
import { Required } from '@rxap/utilities';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i2 from '@rxap/pipes';
import { GetFromObjectPipeModule } from '@rxap/pipes';

class DataGridCellDefDirective {
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
    constructor(template) {
        this.template = template;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridCellDefDirective, deps: [{ token: TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.2", type: DataGridCellDefDirective, selector: "[rxapDataGridCellDef]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridCellDefDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[rxapDataGridCellDef]',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef, decorators: [{
                    type: Inject,
                    args: [TemplateRef]
                }] }]; } });

class DataGridHeaderCellDefDirective {
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
    constructor(template) {
        this.template = template;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridHeaderCellDefDirective, deps: [{ token: TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.2", type: DataGridHeaderCellDefDirective, selector: "[rxapDataGridHeaderCellDef]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridHeaderCellDefDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[rxapDataGridHeaderCellDef]',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef, decorators: [{
                    type: Inject,
                    args: [TemplateRef]
                }] }]; } });

class DataGridEditCellDefDirective {
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
    constructor(template) {
        this.template = template;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridEditCellDefDirective, deps: [{ token: TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.2", type: DataGridEditCellDefDirective, selector: "[rxapDataGridEditCellDef]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridEditCellDefDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[rxapDataGridEditCellDef]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef, decorators: [{
                    type: Inject,
                    args: [TemplateRef]
                }] }]; } });

class DataGridRowDefDirective {
    constructor() {
        this.data = null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridRowDefDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.2", type: DataGridRowDefDirective, selector: "[rxapDataGridRowDef]", inputs: { data: "data", name: ["rxapDataGridRowDef", "name"] }, queries: [{ propertyName: "cell", first: true, predicate: DataGridCellDefDirective, descendants: true }, { propertyName: "headerCell", first: true, predicate: DataGridHeaderCellDefDirective, descendants: true }, { propertyName: "editCell", first: true, predicate: DataGridEditCellDefDirective, descendants: true }], ngImport: i0 }); }
}
__decorate([
    Required,
    __metadata("design:type", String)
], DataGridRowDefDirective.prototype, "name", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridRowDefDirective, decorators: [{
            type: Directive,
            args: [{
                    // tslint:disable-next-line:directive-selector
                    selector: '[rxapDataGridRowDef]'
                }]
        }], propDecorators: { data: [{
                type: Input
            }], name: [{
                type: Input,
                args: ['rxapDataGridRowDef']
            }], cell: [{
                type: ContentChild,
                args: [DataGridCellDefDirective]
            }], headerCell: [{
                type: ContentChild,
                args: [DataGridHeaderCellDefDirective]
            }], editCell: [{
                type: ContentChild,
                args: [DataGridEditCellDefDirective]
            }] } });

class DataGridModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.2", ngImport: i0, type: DataGridModule, declarations: [DataGridRowDefDirective,
            DataGridHeaderCellDefDirective,
            DataGridCellDefDirective,
            DataGridEditCellDefDirective], exports: [DataGridRowDefDirective,
            DataGridHeaderCellDefDirective,
            DataGridCellDefDirective,
            DataGridEditCellDefDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DataGridRowDefDirective,
                        DataGridHeaderCellDefDirective,
                        DataGridCellDefDirective,
                        DataGridEditCellDefDirective
                    ],
                    exports: [
                        DataGridRowDefDirective,
                        DataGridHeaderCellDefDirective,
                        DataGridCellDefDirective,
                        DataGridEditCellDefDirective
                    ]
                }]
        }] });

class DataGridReadonlyComponent {
    constructor() {
        this.header = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridReadonlyComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.2", type: DataGridReadonlyComponent, selector: "rxap-data-grid-readonly", inputs: { header: "header", data: "data" }, host: { classAttribute: "rxap-data-grid-readonly" }, queries: [{ propertyName: "rows", predicate: DataGridRowDefDirective }], ngImport: i0, template: "<table>\n  <thead *ngIf=\"header\">\n  <tr>\n    <th>Label</th>\n    <th>Wert</th>\n  </tr>\n  </thead>\n  <tr *ngFor=\"let row of rows\">\n    <ng-container\n      *ngTemplateOutlet=\"\n          row.headerCell ? row.headerCell.template : defaultHeaderCell;\n          context: { $implicit: row.name }\n        \"\n    ></ng-container>\n    <ng-container\n      *ngTemplateOutlet=\"\n          row.cell ? row.cell.template : defaultCell;\n          context: { $implicit: data | getFromObject: row.name, data: data }\n        \"\n    ></ng-container>\n  </tr>\n</table>\n\n<ng-template #defaultCell let-value>\n  <td>{{ value }}</td>\n</ng-template>\n<ng-template #defaultHeaderCell let-name>\n  <th>{{ name }}</th>\n</ng-template>\n", styles: [""], dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "pipe", type: i2.GetFromObjectPipe, name: "getFromObject" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
__decorate([
    Required,
    __metadata("design:type", Object)
], DataGridReadonlyComponent.prototype, "data", void 0);
__decorate([
    Required,
    __metadata("design:type", QueryList)
], DataGridReadonlyComponent.prototype, "rows", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridReadonlyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'rxap-data-grid-readonly', changeDetection: ChangeDetectionStrategy.OnPush, host: { class: 'rxap-data-grid-readonly' }, template: "<table>\n  <thead *ngIf=\"header\">\n  <tr>\n    <th>Label</th>\n    <th>Wert</th>\n  </tr>\n  </thead>\n  <tr *ngFor=\"let row of rows\">\n    <ng-container\n      *ngTemplateOutlet=\"\n          row.headerCell ? row.headerCell.template : defaultHeaderCell;\n          context: { $implicit: row.name }\n        \"\n    ></ng-container>\n    <ng-container\n      *ngTemplateOutlet=\"\n          row.cell ? row.cell.template : defaultCell;\n          context: { $implicit: data | getFromObject: row.name, data: data }\n        \"\n    ></ng-container>\n  </tr>\n</table>\n\n<ng-template #defaultCell let-value>\n  <td>{{ value }}</td>\n</ng-template>\n<ng-template #defaultHeaderCell let-name>\n  <th>{{ name }}</th>\n</ng-template>\n" }]
        }], propDecorators: { header: [{
                type: Input
            }], data: [{
                type: Input
            }], rows: [{
                type: ContentChildren,
                args: [DataGridRowDefDirective]
            }] } });

class DataGridReadonlyComponentModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridReadonlyComponentModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.2", ngImport: i0, type: DataGridReadonlyComponentModule, declarations: [DataGridReadonlyComponent], imports: [GetFromObjectPipeModule,
            CommonModule], exports: [DataGridReadonlyComponent,
            DataGridModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridReadonlyComponentModule, imports: [GetFromObjectPipeModule,
            CommonModule, DataGridModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridReadonlyComponentModule, decorators: [{
            type: NgModule,
            args: [{
                    exports: [
                        DataGridReadonlyComponent,
                        DataGridModule
                    ],
                    imports: [
                        GetFromObjectPipeModule,
                        CommonModule
                    ],
                    declarations: [
                        DataGridReadonlyComponent
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { DataGridCellDefDirective, DataGridEditCellDefDirective, DataGridHeaderCellDefDirective, DataGridModule, DataGridReadonlyComponent, DataGridReadonlyComponentModule, DataGridRowDefDirective };
//# sourceMappingURL=rxap-data-grid.mjs.map
